#ifndef __OTHER_H__
#define __OTHER_H__

/* these structures don't have a simple equivalent from the server */

/* Structure definition for unknown generic object */
struct Object_type_337_ca { /* 337 */
	short ef_type;
	u_char     fld_owner           ; /* 2 */
	short      fld_uid             ; /* 3 */
	short      fld_xloc            ; /* 3 */
	short      fld_yloc            ; /* 3 */
	u_char     fld_type            ; /* 2 */
	u_char     fld_effic           ; /* 2 */
	char *     fld_mobil           ; /* 1 */
	short      fld_sell            ; /* 3 */
	short      fld_tech            ; /* 3 */
	char *     fld_group           ; /* 1 */
	short      fld_opx             ; /* 3 */
	short      fld_opy             ; /* 3 */
	short      fld_mission         ; /* 3 */
	u_short    fld_pstage          ; /* 4 */
	u_short    fld_ptime           ; /* 4 */
	u_short    fld_che             ; /* 4 */
	u_short    fld_civil           ; /* 4 */
	u_short    fld_milit           ; /* 4 */
	u_short    fld_shell           ; /* 4 */
	u_short    fld_gun             ; /* 4 */
	u_short    fld_petrol          ; /* 4 */
	u_short    fld_iron            ; /* 4 */
	u_short    fld_dust            ; /* 4 */
	u_short    fld_bar             ; /* 4 */
	u_short    fld_food            ; /* 4 */
	u_short    fld_oil             ; /* 4 */
	u_short    fld_lcm             ; /* 4 */
	u_short    fld_hcm             ; /* 4 */
	u_short    fld_uw              ; /* 4 */
	u_short    fld_rad             ; /* 4 */

#ifdef Object_type_337_ca_EXTRA
	Object_type_337_ca_EXTRA
#endif

};

/* Structure definition for version */
struct gameinfo { /* 208 */
	short ef_type;
	int        fld_MAXNOC          ; /* 5 */
	int        fld_WORLD_X         ; /* 5 */
	int        fld_WORLD_Y         ; /* 5 */
	char *     fld_data            ; /* 1 */
	char *     fld_info            ; /* 1 */
	char *     fld_port            ; /* 1 */
	char *     fld_privname        ; /* 1 */
	char *     fld_privlog         ; /* 1 */
	float      fld_btu_build_rate  ; /* 7 */
	float      fld_easy_tech       ; /* 7 */
	float      fld_hard_tech       ; /* 7 */
	float      fld_start_tech      ; /* 7 */
	float      fld_start_happy     ; /* 7 */
	float      fld_start_research  ; /* 7 */
	float      fld_start_edu       ; /* 7 */
	float      fld_land_mob_scale  ; /* 7 */
	float      fld_level_age_rate  ; /* 7 */
	float      fld_plane_mob_scale ; /* 7 */
	float      fld_sect_mob_scale  ; /* 7 */
	float      fld_ship_mob_scale  ; /* 7 */
	float      fld_tech_log_base   ; /* 7 */
	float      fld_ally_factor     ; /* 7 */
	float      fld_edu_avg         ; /* 7 */
	float      fld_hap_avg         ; /* 7 */
	int        fld_startmob        ; /* 5 */
	int        fld_at_least_one_100; /* 5 */
	int        fld_buil_bh         ; /* 5 */
	int        fld_etu_per_update  ; /* 5 */
	int        fld_land_grow_scale ; /* 5 */
	int        fld_land_mob_max    ; /* 5 */
	int        fld_m_m_p_d         ; /* 5 */
	int        fld_max_btus        ; /* 5 */
	int        fld_max_idle        ; /* 5 */
	int        fld_plane_grow_scale; /* 5 */
	int        fld_plane_mob_max   ; /* 5 */
	int        fld_players_at_00   ; /* 5 */
	int        fld_sect_mob_max    ; /* 5 */
	int        fld_ship_grow_scale ; /* 5 */
	int        fld_ship_mob_max    ; /* 5 */
	int        fld_torpedo_damage  ; /* 5 */
	double     fld_buytax          ; /* 8 */
	double     fld_flakscale       ; /* 8 */
	double     fld_maxmult         ; /* 8 */
	double     fld_minmult         ; /* 8 */
	double     fld_tradetax        ; /* 8 */
	double     fld_uwbrate         ; /* 8 */
	double     fld_buil_bc         ; /* 8 */
	double     fld_buil_bt         ; /* 8 */
	double     fld_combat_mob      ; /* 8 */
	double     fld_edu_cons        ; /* 8 */
	double     fld_hap_cons        ; /* 8 */
	double     fld_money_civ       ; /* 8 */
	double     fld_money_land      ; /* 8 */
	double     fld_money_mil       ; /* 8 */
	double     fld_money_plane     ; /* 8 */
	double     fld_money_res       ; /* 8 */
	double     fld_money_ship      ; /* 8 */
	double     fld_money_uw        ; /* 8 */
	double     fld_people_damage   ; /* 8 */
	double     fld_powe_cost       ; /* 8 */
	double     fld_unit_damage     ; /* 8 */
	double     fld_collateral_dam  ; /* 8 */
	double     fld_assault_penalty ; /* 8 */
	double     fld_babyeat         ; /* 8 */
	double     fld_bankint         ; /* 8 */
	double     fld_eatrate         ; /* 8 */
	double     fld_fcrate          ; /* 8 */
	double     fld_fgrate          ; /* 8 */
	double     fld_obrate          ; /* 8 */
	double     fld_mission_mob_cost; /* 8 */
	long       fld_adj_update      ; /* 6 */
	long       fld_s_p_etu         ; /* 6 */
	int        fld_fuel_mult       ; /* 5 */
	long       fld_last_demand_update; /* 6 */
	float      fld_drnuke_const    ; /* 7 */
	float      fld_fire_range_factor; /* 7 */
	int        fld_morale_base     ; /* 5 */
	int        fld_sect_mob_neg_factor; /* 5 */
	int        fld_trade_1_dist    ; /* 5 */
	int        fld_trade_2_dist    ; /* 5 */
	int        fld_trade_3_dist    ; /* 5 */
	float      fld_trade_1         ; /* 7 */
	float      fld_trade_2         ; /* 7 */
	float      fld_trade_3         ; /* 7 */
	float      fld_trade_ally_bonus; /* 7 */
	float      fld_trade_ally_cut  ; /* 7 */
	char *     fld_NEW_MOB         ; /* 1 */
	char *     fld_MOB_ACCESS      ; /* 1 */
	char *     fld_EURO            ; /* 1 */
	char *     fld_RESEARCH        ; /* 1 */
	char *     fld_LOANS           ; /* 1 */
	char *     fld_MARKET          ; /* 1 */
	char *     fld_NOFOOD          ; /* 1 */
	char *     fld_SNEAK_ATTACK    ; /* 1 */
	char *     fld_BLITZ           ; /* 1 */
	char *     fld_HIDDEN          ; /* 1 */
	char *     fld_LOSE_CONTACT    ; /* 1 */
	char *     fld_NONUKES         ; /* 1 */
	char *     fld_FUEL            ; /* 1 */
	char *     fld_TRADESHIPS      ; /* 1 */
	char *     fld_NEWPOWER        ; /* 1 */
	char *     fld_NOMOBCOST       ; /* 1 */
	char *     fld_SUPER_BARS      ; /* 1 */
	char *     fld_EASY_BRIDGES    ; /* 1 */
	char *     fld_ALL_BLEED       ; /* 1 */
	char *     fld_DRNUKE          ; /* 1 */
	char *     fld_SLOW_WAR        ; /* 1 */
	char *     fld_PLAGUE          ; /* 1 */
	char *     fld_NEW_STARVE      ; /* 1 */
	char *     fld_NEW_WORK        ; /* 1 */
	char *     fld_RES_POP         ; /* 1 */
	char *     fld_GRAB_THINGS     ; /* 1 */
	char *     fld_SHOWPLANE       ; /* 1 */
	char *     fld_ORBIT           ; /* 1 */
	char *     fld_PINPOINTMISSILE ; /* 1 */
	char *     fld_FALLOUT         ; /* 1 */
	char *     fld_SAIL            ; /* 1 */
	char *     fld_NUKEFAILDETONATE; /* 1 */
	char *     fld_SHIPNAMES       ; /* 1 */
	char *     fld_NEUTRON         ; /* 1 */
	char *     fld_UPDATESCHED     ; /* 1 */
	char *     fld_DEMANDUPDATE    ; /* 1 */
	char *     fld_BIG_CITY        ; /* 1 */
	char *     fld_INTERDICT_ATT   ; /* 1 */
	char *     fld_FORTFIRE        ; /* 1 */
	char *     fld_BIGSTART        ; /* 1 */

#ifdef gameinfo_EXTRA
	gameinfo_EXTRA
#endif

};

#endif
