/*
 * commodity.h
 *
 * defs for "buy/market/sell" commands
 *
 * from Pat Loney, 6/92
 */
#define MARK_DELAY 36000

struct comstr {
        short   ef_type;
	natid	com_owner;
	short	com_uid;
	char	com_type;
	int	com_amount;
	float	com_price;
	int	com_maxbidder;
	float	com_maxprice;
	time_t  com_markettime;
      coord   com_x;
      coord   com_y;
	coord	sell_x;
	coord	sell_y;
};

#define getcomm(n, p) \
	ef_read(EF_COMM, n, (caddr_t)p)
#define putcomm(n, p) \
	ef_write(EF_COMM, n, (caddr_t)p)
